"""Classes to cover most comparative modeling tasks.

   Use the automodel class to build one of more comparative models.
   Use the allhmodel class instead if you want to build all-atom models.
   Use the loopmodel class if you additionally want to refine loop regions.
"""

from automodel import automodel
from allhmodel import allhmodel
from loopmodel import loopmodel
from dope_loopmodel import dope_loopmodel
from dopehr_loopmodel import dopehr_loopmodel
import refine
import generate
import randomize
import assess
import autosched
